#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct Coche  { float peso;     int pasajeros;  char modelo[20]; };

struct Moto   { int cubicaje;   char fabricante[15]; };

struct Camion {  char marca[15];  double tara;  int ejes;};

enum TipoDeVehiculo { Coche, Moto, Camion };

union Registro {
  struct Coche coche;
  struct Moto moto;
  struct Camion camion;
};

struct Vehiculo {
  enum TipoDeVehiculo tag;
  union Registro r;
};

int main(int argc, char *argv[])
{
  struct Vehiculo lista[3];
  int i;
  /* Asignación de valores a los tres elementos  de la lista */
  lista[0].tag                = Camion;
  strcpy(lista[0].r.camion.marca, "Pegaso");
  lista[0].r.camion.tara      = 12500.0;
  lista[0].r.camion.ejes      = 2;

  lista[1].tag                = Coche;
  strcpy(lista[1].r.coche.modelo, "Seat 600");
  lista[1].r.coche.pasajeros  = 4;
  lista[1].r.coche.peso       = 615.0;

  lista[2].tag                = Moto;
  strcpy(lista[2].r.moto.fabricante, "Vespa");
  lista[2].r.moto.cubicaje    = 125;

  for(i=0;i < 3; i++)
    {
      switch(lista[i].tag)
        {
          case Moto:
                printf("Moto - Cubicaje : %15d  - Fabricante : %15s\n",
                        lista[i].r.moto.cubicaje,
                        lista[i].r.moto.fabricante);
                break;
          case Coche:
                printf("Coche - Peso    : %15.2f  - Pasajeros  : %15d - \
Modelo : %15s\n",
                        lista[i].r.coche.peso,
                        lista[i].r.coche.pasajeros,
                        lista[i].r.coche.modelo);
                break;
          case Camion:
                printf("Camión - Marca  : %15s  - Tara       : %15.2f - \
Ejes   : %15d\n",
                        lista[i].r.camion.marca,
                        lista[i].r.camion.tara,
                        lista[i].r.camion.ejes);
                break;
          default:
                printf("\n\nError fatal, marcador desconocido.\n\n");
                exit(1);
                break;
        }
    }
  return 0;
}
