#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "aplicacion.h"

/*
	Esta parte del programa es fija,
	no requiere modificaciones.
 */

void salir(GlobRef g)
{
	charRef nosVamos = pedir("\n\n¿Desea salir del programa (S/N)?... ");
	if ('S' == toupper(nosVamos[0]))
		g->salirDePrograma = 1;
}

void volver(GlobRef g)
{
	printf("\n\n***\7Opción incorrecta***\n\n");
	return;
}

void distribuidor(	GlobRef  g,
					charRef  men,
					charRef  opc,
					funRef * fun)
{
	char buf[16];
	char orden;
	int numOpciones = 0;
	int numFunciones = 0;
	int i;
	/*
	 Nueva estructura de datos
	 */
	funRef * f;
	/*
	 Se determina el número de opciones
	 */
	numOpciones = strlen(opc);
	/*
	 Se determina el número de funciones
	 */
	while(fun[numFunciones])
		numFunciones++;
	/*
	 Si numOpciones y numFunciones no coinciden,
	 se emite un mensaje de error y se abandona
	 la ejecución del programa.
	 */
	if (numOpciones != numFunciones)
	{
		printf("\n\nError fatal: numOpciones (%d) =! numFunciones (%d)\n\n",
			   numOpciones, numFunciones);
		exit(1);
	}
	/*
	 Si todo va bien, se crea una nueva estructura de datos
	 para simplificar la ejecución. Se puede pensar que se trata
	 de una tabla dispersiva (véase Hash Table) muy primitiva.
	 
	 El mecanismo consiste en crear una tabla formada por 256 posibles
	 valores de tipo pfuncion. En cada posición de la tabla se almacena
	 originalmente la dirección volver.
	 */
	f = malloc(256*sizeof(funRef));
	for(i=0;i<256;i++)
		f[i] = volver;
	/*
	 A continuación, se recorre la lista de opciones correspondientes
	 a funciones. Cada opción es un número. Se utiliza ese número como índice
	 dentro de la lista de funciones, y en la posición correspondiente
	 se almacena el puntero de función asociado a esa opción.
	 
	 Según se ha construido la aplicación, opc[i] es la i-ésima opción
	 (por ejemplo, opc[0] es 'A'), y tiene asociada fun[i] (por ejemplo,
															fun[0] es &altas). Se toma la opción (por ejemplo, 'A', esto es, 65) como
	 índice dentro de la tabla f[] y se hace f[opc[i]] = fun[i]. En nuestro caso,
	 estaríamos haciendo f[65] = &altas;
	 */
	for(i=0;i<numOpciones;i++)
		f[opc[i]] = fun[i];
	/************************************************************
		Ahora la opción pulsada por el usuario es directamente
		el índice de la función seleccionada
		*************************************************************/
	do
	{
		printf("%s ", men);
		fgets(buf, 16, stdin);
		orden = toupper(buf[0]);
		f[orden](g);
	} while (!g->salirDePrograma);
	free(f);
}
