#include "ficheros.h"

int leerLista(  charRef nombreDelFichero,
                charRef ** pListaDeLineas,
                intRef pNumeroDeLineasLeidas)
{
  charRef separador   = NULL;  /* Direccin de retorno o salto */
  charRef temp        = NULL;  /* Direccin de una lnea       */
  charRef linea       = NULL;  /* Linea temporal, optimizacin */
  size_t longitud     = 0;     /* longitud de esa lnea        */
  int n               = 0;     /* Contador de lneas           */
  int capacidad       = 500;   /* Capacidad inicial            */
  int i               = 0;
  FILE * fp = fopen(nombreDelFichero, "r");
  if (!fp)
    {
        printf("\n\nError en leerLista: \"%s\" - %s\n\n\a",
        					nombreDelFichero,
        					strerror(errno));
        return 1;
    }
  /*
     Se reserva espacio para unas cuantas lneas
  */
  charRef * p = malloc(capacidad*sizeof(charRef));
  while (temp = fgetln(fp,&longitud))
    {
      linea = malloc(longitud+1); /* Para aadir el '\0' */
      memcpy(linea, temp,longitud);
      linea[longitud] = '\0';
      if (separador = strchr(linea,'\n')) *separador = '\0';
      if (separador = strchr(linea,'\r')) *separador = '\0';
      p[n] = linea;
      n++;
      if (n == capacidad)
      {
          capacidad +=500;
          p = realloc(p,capacidad*sizeof(charRef));
      }
    }
  fclose(fp);
  /*
  	La informacin se devuelve a travs de los argumentos
  */
  *pListaDeLineas        = p;
  *pNumeroDeLineasLeidas = n;
  return 0;
}


int leerTablaReales(			floatRef * p,
													int numFilas,
													int numCols,
													charRef nombreDelArchivo)
{
	int numDatos        = 0;     /* numFilas * numCols           */
	int i               = 0;     /* ndice de uso general        */
	int numErrores      = 0;		 /* Nmero de errores de lectura */
	floatRef temp       = NULL;  /* Bloque para almacenar datos  */
	FILE * fp           = NULL;
	
	numDatos            = numFilas * numCols;
	temp                = malloc(sizeof(float)*numDatos);

	fp                  = fopen(nombreDelArchivo, "r");
	if (fp)
    {
        for(i=0; i<numDatos;i++)
					if (1 != fscanf(fp,"%f",temp+i))
						{
							*(temp+i) = nanf(0);
							fscanf(fp, "%*s");
							numErrores++;
						}
        fclose(fp);
        *p = temp;
    }
	else
		printf("\nleerTablasReales - Error : %s\n", strerror(errno));
	return numErrores;
}

int mostrarTablaReales(floatRef tabla, int numFilas, int numCols)
{
	int i;
	charRef fmt = "%10.4f"; /* Formato encolumnado razonable     */
	charRef fRet = "%10.4f\n"; /* Formato encolumnado razonable     */
	int n = numFilas * numCols;
	if (tabla)
    {
        for(i=0;i<n;i++)
            printf((i+1)%numCols ? fmt:fRet,tabla[i]);
    }
	else
    {
        return 1;
    }
    return 0;
}
